// PixelMapView.cpp :  Դϴ.
//

#include "stdafx.h"
#include "GsiScrollView01.h"
#include "PixelMapView.h"

#include "GsiScrollView01Dlg.h"

extern CGsiScrollView01Dlg* g_pScrollViewDlg;

#define PIXEL_PER_SIZE	10

#define COLOR_GBACKGROUND	RGB(0, 38, 26)
#define COLOR_GRIDLINE		RGB(101, 101, 101)
#define COLOR_CELL_TYPE0	RGB(204, 255, 102)

//
IMPLEMENT_DYNCREATE(CDummyDoc, CDocument)

// CPixelMapView

IMPLEMENT_DYNCREATE(CPixelMapView, CZoomView)

CPixelMapView::CPixelMapView()
{
	m_ScaleValue = 0.f;
	m_MousePos = CPoint(0, 0);
	m_MousePosToGrid = CPoint(0, 0);

	m_DataList.clear();
}

CPixelMapView::~CPixelMapView()
{
}


BEGIN_MESSAGE_MAP(CPixelMapView, CZoomView)
	ON_WM_LBUTTONDOWN()
END_MESSAGE_MAP()


// CPixelMapView ׸Դϴ.

void CPixelMapView::OnInitialUpdate()
{
	CZoomView::OnInitialUpdate();

// 	CSize sizeTotal;
// 	// TODO:   ü ũ⸦ մϴ.
// 	sizeTotal.cx = sizeTotal.cy = 100;
// 	SetScrollSizes(MM_TEXT, sizeTotal);

	// Initialize the CZoomView class
	SetZoomSizes(CSize(1024*PIXEL_PER_SIZE,1024*PIXEL_PER_SIZE));
}

void CPixelMapView::OnDraw(CDC* pDC)
{
//	CDocument* pDoc = GetDocument();
	
	// 
	DrawBackground(pDC);
	// ׸
	DrawGrid(pDC);
	// 
	DrawItem(pDC);
}


// CPixelMapView Դϴ.

#ifdef _DEBUG
void CPixelMapView::AssertValid() const
{
	CZoomView::AssertValid();
}

void CPixelMapView::Dump(CDumpContext& dc) const
{
	CZoomView::Dump(dc);
}
#endif //_DEBUG


// CPixelMapView ޽ óԴϴ.

BOOL CPixelMapView::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
	//	return CZoomView::OnEraseBkgnd(pDC);
}

/////////////////////////////////////////////////////////////////////////////
// CTestView message handlers
//
/*---------------------------------------------------------------------------
FUNCTION: OnViewZoomin
PURPOSE : User pressed the ZOOM IN toolbutton or menu
---------------------------------------------------------------------------*/
void CPixelMapView::OnViewZoomin()
{
	// Toggle zoomin mode
	CWnd *pWin = ((CWinApp *) AfxGetApp())->m_pMainWnd;
	if (GetZoomMode() == MODE_ZOOMIN) {
		SetZoomMode(MODE_ZOOMOFF);
		// Clear the statusbar
		pWin->SendMessage(WM_SETMESSAGESTRING, 0, 
			(LPARAM)(LPCSTR)"");
	} else {
		SetZoomMode(MODE_ZOOMIN);
		// Give instructions in the statusbar
		pWin->SendMessage(WM_SETMESSAGESTRING, 0, 
			(LPARAM)(LPCSTR)"Click to zoom in on point or drag a zoom box.");
	}
} // OnViewZoomin

/*---------------------------------------------------------------------------
FUNCTION: OnViewZoomout
PURPOSE : User pressed the ZOOM OUT toolbutton or menu
---------------------------------------------------------------------------*/
void CPixelMapView::OnViewZoomout()
{
	// Toggle zoomout mode
	CWnd *pWin = ((CWinApp *) AfxGetApp())->m_pMainWnd;
	if (GetZoomMode() == MODE_ZOOMOUT) {
		SetZoomMode(MODE_ZOOMOFF);
		// Clear the statusbar
		pWin->SendMessage(WM_SETMESSAGESTRING, 0, 
			(LPARAM)(LPCSTR)"");
	} else {
		SetZoomMode(MODE_ZOOMOUT);
		// Give instructions in the statusbar
		pWin->SendMessage(WM_SETMESSAGESTRING, 0, 
			(LPARAM)(LPCSTR)"Click to zoom out on point.");
	}
} // OnViewZoomout

/*---------------------------------------------------------------------------
FUNCTION: OnViewZoomfull
PURPOSE : User pressed the ZOOM FULL toolbutton or menu
---------------------------------------------------------------------------*/
void CPixelMapView::OnViewZoomfull()
{
	DoZoomFull();  // Call CZoomView member to zoom full scale
} // OnViewZoomfull

// 
void CPixelMapView::DrawBackground(CDC* pDC)
{
	CBrush *oldBrush;
	CBrush brush;
	brush.CreateSolidBrush(COLOR_GBACKGROUND);
	oldBrush = pDC->SelectObject(&brush);

	CRect rect(0, 0, m_totalLog.cx, m_totalLog.cy);
	pDC->Rectangle(&rect);

	pDC->SelectObject(oldBrush);
}

// ׸
void CPixelMapView::DrawGrid(CDC* pDC)
{
	CPen     *oldPen;

	//	pDC->SetBkMode(TRANSPARENT);

	CPen newPen(PS_SOLID, 1, COLOR_GRIDLINE); // 0 width = 1 device unit
	oldPen = pDC->SelectObject(&newPen);

	int width  = m_totalLog.cx / PIXEL_PER_SIZE;
	int height = m_totalLog.cy / PIXEL_PER_SIZE;

	CPoint pstart = CPoint(0, 0);
	CPoint pend = CPoint(0, height*PIXEL_PER_SIZE);

	//   ɵ..
	for (int col = 0; col < width; col++) {
		pstart.x += PIXEL_PER_SIZE;
		pend.x += PIXEL_PER_SIZE;
		pDC->MoveTo(pstart);
		pDC->LineTo(pend);
	}

	pstart = CPoint(0, 0);
	pend = CPoint(width*PIXEL_PER_SIZE, 0);
	for (int row = 0; row < height; row++) {
		pstart.y += PIXEL_PER_SIZE;
		pend.y += PIXEL_PER_SIZE;
		pDC->MoveTo(pstart);
		pDC->LineTo(pend);
	}

	//  
	pstart = CPoint(0, 0);
	pend = CPoint(0, height*PIXEL_PER_SIZE);
	for (int col = 0; col < width; col++) {
		if(col == 0 || col % 10 == 0) {
			CString str;
			str.Format("%d", col);
			pDC->TextOut(pstart.x, 10, str);
		}

		pstart.x += PIXEL_PER_SIZE;
		pend.x += PIXEL_PER_SIZE;
	}

	pstart = CPoint(0, 0);
	pend = CPoint(width*PIXEL_PER_SIZE, 0);
	for (int row = 0; row < height; row++) {
		if(row == 0 || row % 10 == 0) {
			CString str;
			str.Format("%d", row);
			pDC->TextOut(10, pstart.y, str);
		}

		pstart.y += PIXEL_PER_SIZE;
		pend.y += PIXEL_PER_SIZE;
	}

	pDC->SelectObject(oldPen);
}

// 
void CPixelMapView::DrawItem(CDC* pDC)
{
	CPen     *oldPen;
	CBrush brush, *oldbrush;
	brush.CreateSolidBrush(COLOR_CELL_TYPE0);
	CPen newPen(PS_SOLID, 1, RGB(255, 0, 0)); // 0 width = 1 device unit
	oldbrush = pDC->SelectObject(&brush);
	oldPen = pDC->SelectObject(&newPen);

	vector<CPoint>::iterator iter;
	for(iter = m_DataList.begin(); iter != m_DataList.end(); ++iter)
	{
		int left = (*iter).x * PIXEL_PER_SIZE;
		int top = (*iter).y * PIXEL_PER_SIZE;

		//簢 ׸.
		CRect rect = CRect(left, top, left + PIXEL_PER_SIZE, top + PIXEL_PER_SIZE);
		pDC->FillRect(rect, &brush);

		pDC->Rectangle(&rect);
	}

	pDC->SelectObject(oldbrush);
	pDC->SelectObject(oldPen);
}

void CPixelMapView::OnLButtonDown(UINT nFlags, CPoint point)
{
	CZoomView::OnLButtonDown(nFlags, point);

	if(GetZoomMode() == MODE_ZOOMOFF) {
		//ش ġ  Ѵ.
		m_ScaleValue = GetZoomScale();
		m_MousePos = point;

		//ũ 
		// Special case for printing
		CSize  printSize;
		printSize.cx = this->GetScrollPos(SB_HORZ);
		printSize.cy = this->GetScrollPos(SB_VERT);
		TRACE2("ScrollPos = %d, %d\n", printSize.cx, printSize.cy);
		CPoint testPos = this->GetScrollPosition();
		TRACE2("ScrollPosition = %d, %d\n", testPos.x, testPos.y);

		CPoint scrollPos = CPoint(printSize.cx, printSize.cy);
		m_MousePos += testPos;

		m_MousePosToGrid = CPoint(m_MousePos.x / PIXEL_PER_SIZE, m_MousePos.y / PIXEL_PER_SIZE);

		m_MousePosToScalePos = CPoint((int)((float)m_MousePos.x / m_ScaleValue), (int)((float)m_MousePos.y / m_ScaleValue));
		m_MousePosToScaleGrid = CPoint((int)((float)m_MousePosToGrid.x / m_ScaleValue), (int)((float)m_MousePosToGrid.y / m_ScaleValue));

		g_pScrollViewDlg->m_PixelMapViewScale.Format("%f", m_ScaleValue);
		g_pScrollViewDlg->m_MousePos.Format("Grid:%d, %d, DcPoint:%d, %d", 
								m_MousePosToGrid.x, m_MousePosToGrid.y, m_MousePos.x, m_MousePos.y);
		g_pScrollViewDlg->m_MousePosToScalePos.Format("Grid:%d, %d, DcPoint:%d, %d",
			m_MousePosToScaleGrid.x, m_MousePosToScaleGrid.y, m_MousePosToScalePos.x, m_MousePosToScalePos.y);

		g_pScrollViewDlg->UpdateData(FALSE);

		// ش ġ  Ѵ.
		m_DataList.push_back(m_MousePosToScaleGrid);

		g_pScrollViewDlg->Invalidate();
	}
}